<template>
    <div>
        <div class="columns">
            <h1 class="title column">Movies</h1>
            <div class="column columns is-mobile">
                <div class="column">
                    <input type="search" class="input" v-model="search" placeholder="Search">
                </div>
                <div class="column has-text-right is-narrow">
                    <router-link :to="{name:'MovieForm', params:{id:'create'}}" class="button is-success">Add New</router-link>
                </div>
            </div>
            <confirm :show="showConfirmModal" :on-confirm="confirmedDeleteRow" :on-cancel="cancelledDeleteRow">
                Are you sure you want to delete this movie?
            </confirm>
        </div>
        <h2 class="subtitle">Filters</h2>
        <vql
                :filters="filters"
                :afterFilter="passBackFilters"
        ></vql>
        <br />
        <transition name="slide-fade">
            <h3 class="subtitle is-loading" v-if="movies.length === 0">Loading ...</h3>
        </transition>
        <transition name="slide-fade">
            <b-table class="is-fullwidth" v-if="movies.length > 0"
                     :data="filtered"
                     :selected.sync="selectedRow"
                     :striped="true"
                     :mobile-cards="true"
                     :paginated="paginated"
                     per-page="25"
                     default-sort="name"
            >
                <template slot-scope="props">
                    <b-table-column field="title" label="Title" sortable>
                        {{ props.row.title }}
                    </b-table-column>
                    <b-table-column field="year" label="Year" sortable>
                        {{ props.row.year }}
                    </b-table-column>
                    <b-table-column field="genre" label="Genre">
                        {{ findGenre(props.row.genre) }}
                    </b-table-column>
                    <b-table-column field="rating" label="Rating" sortable>
                        {{ props.row.rating }} / 5
                    </b-table-column>
                    <b-table-column field="actors" label="Actors">
                        <template v-for="actor in props.row.actors">
                            <span class="tag is-light">{{ actor.first_name }} {{ actor.last_name }}</span>
                            <br />
                        </template>
                    </b-table-column>
                    <b-table-column label="Actions">
                        <template v-if="props.row.modifiable">
                            <router-link :to="{name:'MovieForm', params:{id:props.row.id}}" tag="button" class="button is-flat is-small">
                                <svg class="icon" version="1.1" id="Pencil" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
	 viewBox="0 0 20 20" enable-background="new 0 0 20 20" xml:space="preserve">
                                    <path d="M14.69,2.661c-1.894-1.379-3.242-1.349-3.754-1.266c-0.144,0.023-0.265,0.106-0.35,0.223l-4.62,6.374l-2.263,3.123
	c-0.277,0.382-0.437,0.836-0.462,1.307l-0.296,5.624c-0.021,0.405,0.382,0.698,0.76,0.553l5.256-2.01
	c0.443-0.17,0.828-0.465,1.106-0.849l1.844-2.545l5.036-6.949c0.089-0.123,0.125-0.273,0.1-0.423
	C16.963,5.297,16.56,4.021,14.69,2.661z M8.977,15.465l-2.043,0.789c-0.08,0.031-0.169,0.006-0.221-0.062
	c-0.263-0.335-0.576-0.667-1.075-1.03c-0.499-0.362-0.911-0.558-1.31-0.706c-0.08-0.03-0.131-0.106-0.126-0.192l0.122-2.186
	l0.549-0.755c0,0,1.229-0.169,2.833,0.998c1.602,1.166,1.821,2.388,1.821,2.388L8.977,15.465z"/>
</svg>
                            </router-link>
                            <button title="Delete" class="is-danger button is-flat is-small" @click="deleteRow(props.row)">
                                <svg class="icon" version="1.1" id="Trash" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
	 viewBox="0 0 20 20" enable-background="new 0 0 20 20" xml:space="preserve">
                                    <path d="M3.389,7.113L4.49,18.021C4.551,18.482,6.777,19.998,10,20c3.225-0.002,5.451-1.518,5.511-1.979l1.102-10.908
	C14.929,8.055,12.412,8.5,10,8.5C7.59,8.5,5.072,8.055,3.389,7.113z M13.168,1.51l-0.859-0.951C11.977,0.086,11.617,0,10.916,0
	H9.085c-0.7,0-1.061,0.086-1.392,0.559L6.834,1.51C4.264,1.959,2.4,3.15,2.4,4.029v0.17C2.4,5.746,5.803,7,10,7
	c4.198,0,7.601-1.254,7.601-2.801v-0.17C17.601,3.15,15.738,1.959,13.168,1.51z M12.07,4.34L11,3H9L7.932,4.34h-1.7
	c0,0,1.862-2.221,2.111-2.522C8.533,1.588,8.727,1.5,8.979,1.5h2.043c0.253,0,0.447,0.088,0.637,0.318
	c0.248,0.301,2.111,2.522,2.111,2.522H12.07z"/>
</svg>
                            </button>
                        </template>
                    </b-table-column>
                </template>
            </b-table>
        </transition>
    </div>
</template>

<script>
    import BTable from 'buefy/src/components/table/Table';
    import BTableColumn from 'buefy/src/components/table/TableColumn';
    import axios from 'axios';
    import findIndex from 'lodash/findIndex';
    import Confirm from '../components/confirm';
    import Vql from '../components/forms/vql';
    import year from '../queryables/year';
    import actors from '../queryables/actors';
    import gens from '../queryables/genres';
    import ratings from '../queryables/rating';
    export default {
        components: {
            BTable, BTableColumn, Confirm, Vql
        },
        props:['year', 'actors', 'genre', 'rating'],
        data() {
            return {
                movies:[],
                selectedRow:{id:'create'},
                search:'',
                showConfirmModal:false,
                filters:[
                    actors.queryable(this.actors),
                    gens.queryable(this.genre),
                    ratings.queryable(this.rating),
                    year.queryable(this.year)
                ],
            }
        },
        computed:{
            filtered() {
                return this.movies.filter((item) => {
                    if(this.search.length === 0) {
                        return true;
                    }
                    return item.title.toLowerCase().indexOf(this.search) !== -1;
                })
            },
            formId() {
                return (this.selectedRow !== null)
                    ? this.selectedRow.id
                    : 'create';
            },
            total() {
                return this.movies.length;
            },
            paginated() {
                return this.filtered.length > 25;
            }
        },
        methods:{
            passBackFilters(filters) {
                this.$router.push({query:filters});
                this.$nextTick(() => {
                    this.fetchQuery();
                })
            },
            deleteRow() {
                this.showConfirmModal = true;
            },
            cancelledDeleteRow() {
                this.showConfirmModal = false;
            },
            confirmedDeleteRow() {
                this.showConfirmModal = false;
                axios.delete(route('movies.destroy', {movie:this.selectedRow.id}))
                    .then((reponse) => {
                        let index = findIndex(this.movies, {id:this.selectedRow.id});
                        this.movies.splice(index, 1);
                        this.selectedRow = {id:'create'};
                    });
            },
            findGenre(value) {
                return window.genres.find(function(item) {
                   return item.value === value;
                }).label;
            },
            fetchQuery() {
                let query = ['includes=actors'];
                ['year', 'actors', 'genre', 'rating'].forEach((v) => {
                    if(this[v] !== undefined) {
                        query.push(v + '=' + this[v]);
                    }
                });

                this.loading = true;
                axios.get(route('movies.index') + '?' + query.join('&'))
                    .then(response => {
                        this.movies = response.data.data;
                        this.loading = false;
                    });
            }
        },
        created() {
            this.fetchQuery();
        }
    }
</script>